#include <iostream>

using namespace std;


//klasa kojom se opisuje jedan element liste
class ElementListe
{
public:
        //konstruktor klase ElementListe
	ElementListe( int v, ElementListe* l )
		: Vrednost(v),
		  Sledeci(l)
		{}

        //destruktor  klase ElementListe
	~ElementListe()
		{ delete Sledeci; }

	int Vrednost;
	ElementListe* 	Sledeci;
};

//klasa kojom se opisuje lista
class Lista
{
public:
	//konstruktor klase Lista
	Lista()
		: _Pocetak(0)
		{}

	//destrukto klase Lista
	~Lista()
		{ delete _Pocetak; }

	//metod za dodavanje novog elementa na pocetak liste
	void DodajNaPocetak( int n )
		{
		ElementListe* novi = new ElementListe( n, _Pocetak );
		_Pocetak = novi;
		}

	//metod za dodavanje novog elementa na kraj liste
	void DodajNaKraj( int n )
		{
		ElementListe* novi = new ElementListe( n, 0 );
		if( _Pocetak ){
			ElementListe* p;
			for( p=_Pocetak; p->Sledeci; p=p->Sledeci )
				;
			p->Sledeci = novi;
			}
		else
			_Pocetak = novi;
		}

	//metod koji vraca vrednost i-tog elementa u listi (vazi samo ako postoji i+1-ti element)
	int Element( int i ) const
	{
		ElementListe* p = _Pocetak;
		for( int j=0; j<i; j++ )
			p = p->Sledeci;
		return p->Vrednost;
	}

private:
	ElementListe* _Pocetak;
};

int main()
{
	Lista l;
	for( int i=0; i<10; i++ )
		l.DodajNaPocetak(i);

	for( int i=0; i<10; i++ )
		cout << l.Element(i) << ' ';
	cout << endl;

	return 0;
}
